// Look for sections that have a data-fullscreen-img attribute and set this image as
// the body background image whenever this section is displayed.
// TODO insert image with reveal transition
var BGR;

function fullscreen(event) {
   var fullScreenImageAuthorContainer = document.getElementById('fullscreenImageAuthor');
   var children = fullScreenImageAuthorContainer.childNodes;
   for (var i = 0; i < children.length; i++) {
      fullScreenImageAuthorContainer.removeChild(children[i])
   }
  var url = event.currentSlide.getAttribute("data-fullscreen-img");
  if(url) {
    if(typeof BGR == "undefined")
    {
      // Store background value
      BGR = document.body.style.background;
    }

    // Set image from data-fullscreen-img attribute as body background
    document.body.style.backgroundImage = "url('" + url + "')";
    var size = event.currentSlide.getAttribute("data-fullscreen-size");
    if(size != "contain") {
      document.body.style.backgroundSize = "cover";
    }
    else {
      // Put image in 'contain' mode with black background
      // TODO store background color and use it. This is possible by regexping
      // the background property and replacing the 2nd value by the image url.
      // See http://www.w3schools.com/cssref/css3_pr_background.asp
      document.body.style.backgroundColor = "#000000";
      document.body.style.backgroundSize  = "contain";
      document.body.style.backgroundRepeat = "no-repeat";
      document.body.style.backgroundAttachment = "fixed";
      document.body.style.backgroundPosition = "center center";
    }
     var author = event.currentSlide.getAttribute("data-fullscreen-author");
     if(author) {
        var authorLink = event.currentSlide.getAttribute("data-fullscreen-author-link");
        var authorElement;
        if(authorLink){
           authorElement = document.createElement('a');
           authorElement.setAttribute('target', '_blank');
           authorElement.setAttribute('href', authorLink);
        }else{
           authorElement = document.createElement('span')
        }
        authorElement.appendChild(document.createTextNode(author));
        fullScreenImageAuthorContainer.appendChild(authorElement);
     }
  }
  else { 
    if(typeof BGR != "undefined") { 
      document.body.style.backgroundImage = "none";
      document.body.style.background      = BGR;
    } 
  }
}

Reveal.addEventListener('ready', function(event) {
  fullscreen(event);
}, false );

Reveal.addEventListener('slidechanged', function(event) {
  fullscreen(event);
}, false );

